# Contributing

## Report a bug

Just use a 'bug report' template when creating a new issue.

## Submit a PR

The process of submitting a pull request depends on what kind of changes you have in it:

#### Fix typo/documentation clarification

You can open your PR directly against a `master` branch.

#### Fix a minor bug

Open your PR against the `dev` branch of the repository with a meaningful message in the description.

#### Fix a bug in the library core/implement a new feature

First, open an issue from 'feature request' template or describe in the existing issue what idea you are trying to implement
– probably it needs some tuning to be more aligned with the whole library design and vision.
After a design discussion, you can open a PR against the `dev` branch.

## Propose/implement a new serialization format

If you have created a new serialization format, you can keep it
in your repository to be able to perform proper maintenance and to have a separate release cycle. 
You can submit a PR to the [list of community-supported formats](formats/README.md#other-community-supported-formats) with a description of your library.

## Building this library

You can find all the instructions [here](docs/building.md)
